/**
 1) Schreiben Sie ein Interface IntListable mit den Methoden
 int getFirst()
 IntListable getRest()

 Implementieren Sie zwei Klassen, die das Interface implementieren:
 IntListEmpty
 mit Konstruktor IntListEmpty()
 getFirst() und getRest() liefern Beliebiges
 IntListElement
 mit Konstruktor IntListElement(int v, IntListable n)
 getFirst() liefert v, und getRest() liefert n.

 Schreiben Sie in main(), das ein IntListable mit drei Elementen erzeugt.

 Für die folgenden Aufgaben erweitern Sie das main() passend, um die
 Methoden zu testen.

 2) Implementieren Sie toString() für die Klassen, die IntListable
 implementieren. Verwenden Sie dabei kein if, ?...:, o.ä.

 3) 25% Implementieren Sie equals(Object o) für die Klassen, die
 IntListable implementieren, sodass es true genau dann liefert, wenn
 die verglichenen Listen mit gleichen Konstruktor-Aufrufen aufgebaut
 wurden. Folgendes soll also true liefern:

 (new IntListElement(1, new IntListElement(2, new ListEmpty()))).equals
 (new IntListElement(1, new IntListElement(2, new ListEmpty())))

 4) Definieren Sie eine Methode contains(int key) in IntListable
 und implementieren Sie contains für diie Klassen, die Intlistable
 implementieren. Verwenden Sie dabei kein getClass() oder instanceof.

 (new IntListElement(1, IntListElement(2, new IntListEmpt()))).contains(2)

 sollte true liefern und

 (new IntListElement(1, IntListElement(2, new IntListEmpt()))).contains(3)

 sollte false liefern.

 Nachdem Sie das abgegeben haben, schreiben Sie eine Klasse für einen binären Suchbaum mit passenden Methoden und Unterklassen Ihrer Wahl, und zwar so, dass Sie beim Baumtraversieren
 ohne expliziten Vergleich auf null auskommen. Ist es dabei sinnvoller, eine Unterklasse für Blätter zu haben, eine für einen leeren Baum, oder beides?
 */
public class AdHoc4 {
}


//eventuelle Lösung
/*
public interface IntListable {
    int getFirst();
    IntListable getRest();
    boolean contains(int key);

}

/////////////////////////////////////////////////////////

public class IntListEmpty implements IntListable {


    IntListEmpty() {

    }

    @Override
    public int getFirst() {

        return 0;
    }

    @Override
    public IntListable getRest() {
        return null;
    }

    @Override
    public boolean contains(int key) {
        return false;
    }

    @Override
    public String toString() { return "empt";}

    public boolean equals (Object o) {
        // same object
        if (this == o)
            return true;
        // null or diffrent class
        if (o == null || this.getClass() != o.getClass())
            return false;

        return true;
    }
}

//////////////////////////////////////////////////////////////

public class IntListElement implements IntListable {
    private int value;
    private IntListable n;

    IntListElement(int v, IntListable n) {
        this.value = v;
        this.n = n;
    }

    @Override
    public int getFirst() {
        return this.value;
    }

    @Override
    public IntListable getRest() {
        return this.n;
    }

    @Override
    public String toString() {
        return this.value + ", " + this.n;
    }

    public boolean equals (Object o) {
        // same object
        if (this == o)
            return true;
        // null or diffrent class
        if (o == null || this.getClass() != o.getClass())
            return false;

        // dummy with cast
        IntListElement tmp = (IntListElement) o;

        if (this.value != tmp.value)
            return false;
        if (tmp.getRest() != null && this.getRest() != null) {
            return this.getRest().equals(tmp.getRest());
        }

        return true;
    }

    @Override
    public boolean contains(int key) {
        if (this.getFirst() == key) {
            return true;
        } else {
            return this.getRest().contains(key);
        }
    }

    public static void main(String[] args) {

        IntListable one = new IntListElement(1,new IntListElement(2, new IntListElement(3, new IntListEmpty())));
        IntListable two = new IntListElement(1,new IntListElement(2, new IntListElement(3, new IntListEmpty())));
        IntListable three = new IntListElement(1,new IntListElement(2, new IntListElement(4, new IntListEmpty())));

        System.out.println(one);

        System.out.println("\n****equals****");
        System.out.println(one.equals(two));
        System.out.println(one.equals(three));

        System.out.println("\n***contains***");
        System.out.println(one.contains(3));
        System.out.println(one.contains(4));
        System.out.println(three.contains(4));
    }
}



 */
