/**
 *  Ersetzen Sie die mit "?" gekennzeichneteten Stellen, sodass die
 *  prodi(x,y), prodr(x,y) und prodr2(x,y) jeweils x*y zurückliefern
 *  Verwenden Sie dabei aber nicht den Operator *
 *
 *  Optional: Nachdem Sie obiges abgegeben haben, überlegen Sie, wenn Ihnen noch Zeit übrigbleibt, ob Sie jetzt die Zusatzfrage 4 von Aufgabe 1
 *  (Implementierung von L mit nur einem Rekursiven Aufruf) beantworten können.
 */
public class AdHoc3 {
    public static int Fragezeichen = 0;

    public static void main(String[] args) {
        System.out.println(prodi(6,7));
        System.out.println(prodr(6,7));
        System.out.println(prodr2(6,7));
    }

    // returns x*y, y>=0 is assumes
    public static int prodi(int x, int y) {
        int r = 0;
        while (y > Fragezeichen) {
            r = r + Fragezeichen;
            y = y - Fragezeichen;
        }
        return r;
    }
    // returns x*y, y>=0 is assumed
    public static int prodr(int x, int y){
        return prodr(x,y,0);
    }
    public static int prodr(int x, int y, int r){
        if(y>Fragezeichen){
            r= r+Fragezeichen;
            y=y-Fragezeichen;
            return prodr(x, y, r);
        }
        return r;
    }

    //das gleiche, aber Zuweisungen
    // returns x*y, y>=0 is assumed
    public static int prodr2(int x, int y){
        return prodr2(x,y,0);
    }
    public static int prodr2(int x, int y, int r){
        if(y>Fragezeichen){
            return prodr2(x,y-Fragezeichen,r+Fragezeichen);
        }
        return r;
    }
}