import java.util.Scanner;

public class AdHoc6 {

    public static void createAndFillBoard() {
        int[][] board = new int[3][];

        for (int i=0; i < board.length; i++) {
            board[i] = new int[]{1, 1, 1};
        }

        Scanner scanner = new Scanner(System.in);

        while (true)
        {
            System.out.println("Bitte drücken Sie Enter (und 'e' davor für Ende):");

            String is_e = scanner.nextLine();

            if (is_e.equals("e")) {
                break;
            }

/*******************************************************************************************************
 *                     B E G I N N   IHRER IMPLEMENTIERUNG                                             *
 *******************************************************************************************************/
// a) Lassen Sie diesen Implementierungsblock leer und starten Sie dieses Programm.
//    Betrachten Sie einige Ergebnisse.
//
//    (5 Punkte)
//
// b) board ist ein 3 x 3-Array vom Datentyp Integer.
// Befüllen Sie jedes Element von board mit einer Zufallszahl aus der Menge {-1, 0, 1}.
// Um eine einzelne derartige Zufallszahl zu bekommen, rufen Sie die Methode liefereZufallszahl()
// auf.
// Beenden Sie Ihren Implementierungsblock mit untenstehendem Aufruf printBoard(board, false);
// Testen Sie Ihr Programm.
//
//   (50 Punkte)
//
// c) Berechnen Sie mit Ihrem Programm zusätzlich die Zeilensummen des Arrays board.
// (Der Zeilenindex ist der erste Index von board.)
// Übergeben Sie als zweiten Parameter im abschliessenden Aufruf printBoard(board, ...);
// genau dann true, wenn eine der drei Zeilensummen den Wert -3 oder 3 hat.
// Testen Sie Ihr Programm.
//
//   (45 Punkte)
//

            printBoard(board, false);

/*******************************************************************************************************
 *                        E N D E   IHRER IMPLEMENTIERUNG                                              *
 *******************************************************************************************************/

        }
    }

    public static int liefereZufallszahl() {
        // Diese Methode retourniert eine Zufallszahl die entweder -1, 0 oder 1 ist.
        double double_zufallszahl = Math.random() * 3.;
        int zufallszahl = ((int) double_zufallszahl) - 1;

        return zufallszahl;
    }

    public static void printBoard(int[][] board_local, boolean is_victory) {
        // System.out.println();
        System.out.println("  +---+---+---+");

        for (int[] subarray : board_local) {
            String line = "  | ";

            for (int elem : subarray) {
                String next_field = " ";

                switch(elem) {
                    case -1:
                        next_field = "O";
                        break;
                    case 1:
                        next_field = "X";
                        break;
                }

                line += next_field + " | ";
            }

            System.out.println(line);
            // System.out.println("  |   |   |   |");
            System.out.println("  +---+---+---+");

        }

        if (is_victory) {
            System.out.println();
            System.out.println("  Super ! Es gibt einen Sieger !");
        }

        System.out.println();
    }

    public static void main(String[] args) {
        // System.out.println(liefereZufallszahl());

        createAndFillBoard();
    }
}

